{ turing problem }
{ (c) ZT }
program turing(input, output);
type
  PNode = ^Node;
  Node = record
    left, right: PNode;
    value: char;
    stav1, stav2: integer;
  end;

var
  tree: PNode;
  N, index, tae_len, max_stav, max_letter, nprom, znacka: integer;
  tae: string[255];


{****************
  ladici vypis
****************}
procedure dwriteln(s: string);
begin
{  writeln(s);}
end;

{***************************
  vytvori novy uzel stromu
***************************}
function new_node(ch: char): PNode;
var nn: PNode;
begin
  {writeln('new_node: ', ch);}
  new(nn);
  nn^.left:=nil; nn^.right:=nil;
  nn^.value:=ch;
  new_node:=nn;
end;


{***********************
  lexikalni analyzator
***********************}
function lexan: char;
begin
  if index<=tae_len then lexan:=tae[index]
  else lexan:=' ';
end;

procedure srovnej(ch: char);
begin
  if ch<>tae[index] then begin
    writeln('Expected char ', ch, ' and found ', tae[index]);
  end;
  {writeln('srovnavam znak ', ch);}
  index:=index+1;
end;


{*************************
  syntakticky analyzator
*************************}
procedure E(var st: PNode); forward;
procedure EC(dt: PNode; var st: PNode); forward;
procedure T(var st: PNode); forward;
procedure TC(dt: PNode; var st: PNode); forward;
procedure F(var st: PNode); forward;

procedure E(var st: PNode);
var stn: PNode;
begin
  dwriteln('E');
  case lexan of
    '(','1','2','3','4','5','6','7','8','9': begin 
      T(stn); EC(stn, st); end;
  end;
end;

procedure EC(dt: PNode; var st: PNode);
var stn: PNode;
begin
  dwriteln('EC');
  case lexan of
    '+': begin srovnej('+'); 
      stn:=new_node('+'); stn^.left:=dt;
      T(stn^.right); EC(stn, st); end;
    ')',' ': st:=dt;
  end;
end;
   
procedure T(var st: PNode);
var stn: PNode;
begin
  dwriteln('T');
  case lexan of
    '(','1','2','3','4','5','6','7','8','9': begin 
      F(stn); TC(stn, st); end;
  end;
end;

procedure TC(dt: PNode; var st: PNode);
var stn: PNode;
begin
  dwriteln('TC');
  case lexan of
    '*': begin srovnej('*'); 
           stn:=new_node('*'); stn^.left:=dt;
           F(stn^.right); TC(stn, st);
         end;
    '+',')',' ': st:=dt;
  end;
end;

procedure F(var st: PNode);
begin
  dwriteln('F');
  case lexan of
    '(': begin srovnej('('); E(st); srovnej(')'); end;
    '1': begin srovnej('1'); st:=new_node('1'); end;
    '2': begin srovnej('2'); st:=new_node('2'); end;
    '3': begin srovnej('3'); st:=new_node('3'); end;
    '4': begin srovnej('4'); st:=new_node('4'); end;
    '5': begin srovnej('5'); st:=new_node('5'); end;
    '6': begin srovnej('6'); st:=new_node('6'); end;
    '7': begin srovnej('7'); st:=new_node('7'); end;
    '8': begin srovnej('8'); st:=new_node('8'); end;
    '9': begin srovnej('9'); st:=new_node('9'); end;
  end;
end;
    

{****************************
   vypise strom v postfixu
****************************}
procedure print_tree(t: PNode);
begin
  if t<>nil then begin
    print_tree(t^.left);
    print_tree(t^.right);
    write(t^.value);
  end;
end;

{****************************
   projde strom
****************************}
procedure projdi(t: PNode; var mst: integer);
var iv, lst, rst: integer;
begin
  if t<>nil then begin
    projdi(t^.left, lst);
    projdi(t^.right, rst);
    mst:=lst+rst;
    if (t^.value>='1') and (t^.value<='9') then begin
      iv:=ord(t^.value)-ord('0');
      if iv>nprom then nprom:=iv;
      mst:=mst+iv+34;
    end else if t^.value='+' then mst:=mst+159
    else if t^.value='*' then mst:=mst+60;
  end else mst:=0;
end;

{****************************
   postavi strom
****************************}
procedure build_tree;
var mst: integer;
begin
  tree:=nil;
  index:=1;
  readln(tae);
  tae_len:=Length(tae);
  {writeln('tae: ', tae);}
  E(tree);
  {write('postfix: ');}
  {print_tree(tree);}
  {writeln;}
  nprom:=0;
  projdi(tree, mst);
  mst:=mst+80; { 80 je moc !!! patri sem tak 8 }
  writeln('20 ', mst:1);
end;


{***********************
  zapise instrukci TM 
***********************}
procedure write_inst(st1, let1, let2, st2: integer; d: char);
begin
  writeln(st1:1, ' ', let1:1, ' ', let2:1, ' ', st2:1, ' ', d);
end;

{**************************
  posun vpravo za mezeru
**************************}
procedure vpravo_za_mezeru(var st1: integer);
var i, st2: integer;
begin
  for i:=0 to 9 do
    write_inst(st1, i, i, st1, 'R');
  st2:=st1+1;
  write_inst(st1, -1, -1, st2, 'R');
  st1:=st2;
end;

{***********************************
  posun vlevo za mezery (i nekolik)
***********************************}
procedure vlevo_za_mezery(var st1: integer);
var i, st2, st3, st4: integer;
begin
  for i:=0 to 9 do
    write_inst(st1, i, i, st1, 'L');
  st2:=st1+1;
  write_inst(st1, -1, -1, st2, 'L');
  write_inst(st2, -1, -1, st2, 'L');
  st3:=st2+1;
  for i:=0 to 9 do
    write_inst(st2, i, i, st3, 'R');
  st4:=st3+1;
  write_inst(st3, -1, -1, st4, 'L');
  st1:=st4;
end;

{*****************************
  posun vpravo na k-te cislo
*****************************}
procedure vpravo_na_cislo(k: integer; var st1: integer);
var i: integer;
begin
  for i:=1 to k do
    vpravo_za_mezeru(st1);
end;

{*****************************
  posun vlevo na k-te cislo
*****************************}
procedure vlevo_na_cislo(k: integer; var st1: integer);
var i: integer;
begin
  for i:=1 to k do
    vlevo_za_mezery(st1);
end;

{**************************
  posun vlevo na znacku
**************************}
procedure jdi_vlevo_na(zn: integer; var st1: integer);
var i, st2: integer;
begin
  for i:=-1 to 9 do
    write_inst(st1, i, i, st1, 'L');
  st2:=st1+1;
  write_inst(st1, zn, zn, st2, 'R');
  st1:=st2;
end;

{***************************
  posun vpravo na znacku
***************************}
procedure jdi_vpravo_na(zn: integer; var st1: integer);
var i, st2, st3: integer;
begin
  for i:=-1 to 9 do
    write_inst(st1, i, i, st1, 'R');
  st2:=st1+1;
  write_inst(st1, zn, zn, st2, 'L');
  st3:=st2+1;
  for i:=-1 to 9 do
    write_inst(st2, i, i, st3, 'R');
  st1:=st3;
end;

{***************************
  posun vpravo pred znacku
***************************}
procedure jdi_vpravo_pred(zn: integer; var st1: integer);
var i, st2: integer;
begin
  for i:=-1 to 9 do
    write_inst(st1, i, i, st1, 'R');
  st2:=st1+1;
  write_inst(st1, zn, zn, st2, 'L');
  st1:=st2;
end;

{**************************
  zapise znacky
**************************}
procedure zapis_znacky(var stav, letter: integer);
var i: integer;
begin
  for i:=0 to 9 do
    write_inst(0, i, i, stav+1, 'L');
  letter:=letter+1;
  znacka:=letter;
  for i:=-1 to 9 do
    write_inst(1, i, znacka, stav+2, 'R');
  stav:=stav+2;
  for i:=1 to nprom do
    vpravo_za_mezeru(stav);
  for i:=-1 to 9 do
    write_inst(stav, i, znacka, stav+1, 'L');
  stav:=stav+1;
  jdi_vlevo_na(znacka, stav);
end;

{*********************************
  prepise cislo na konec pasky
    stav - aktualni stav
    letter - max. pismeno abecedy
**********************************}
procedure prepis_cislo(var stav, letter: integer);
var pstav, ps2, ps3, zn, ps4, ps5, ps6, i, j: integer;
begin
  for i:=0 to 9 do begin
    pstav:=stav+1+i; zn:=letter+1+i;
    { prepis cislo znackou }
    write_inst(stav, i, zn, pstav, 'R');
    { jdi na koncovou znacku }
    for j:=-1 to 9 do
      write_inst(pstav, j, j, pstav, 'R');
    { prepis znacku cislem }
    ps2:=stav+11+i; ps3:=stav+21+i;
    write_inst(pstav, znacka, i, ps2, 'R');
    { zapis znacku }
    for j:=-1 to 9 do
      write_inst(ps2, j, znacka, ps3, 'L');
    { jdi na pocatecni znacku }
    for j:=-1 to 9 do
      write_inst(ps3, j, j, ps3, 'L');
    { prepis znacku zpet na cislo }
    write_inst(ps3, zn, i, stav, 'R');
  end;
  { prepis i mezeru za cislem }
  ps4:=stav+31;
  write_inst(stav, -1, -1, ps4, 'R');
  { jdi na koncovou znacku }
  for j:=-1 to 9 do
    write_inst(ps4, j, j, ps4, 'R');
  { prepis znacku mezerou }
  ps5:=ps4+1; ps6:=ps4+2;
  write_inst(ps4, znacka, -1, ps5, 'R');
  { zapis znacku }
  for j:=-1 to 9 do
    write_inst(ps5, j, znacka, ps6, 'L');
  { jdi na pocatecni znacku }
  for j:=-1 to 9 do
    write_inst(ps6, j, j, ps6, 'L');
  stav:=ps6+1;
  write_inst(ps6, znacka, znacka, stav, 'R');
end;

{************************************
  secte dve cisla
************************************}
procedure secti(var stav, letter: integer);
var i, j, pstav, ps1, ps2, v, zn, zn2, ps3, ps4, ps5, ps6, ps7, ps8, ps9,
  ps10, ps11, ps12, ps13, ps14, ps15, ps16, ps17, ps18, ps19, ps20,
  ps21, ps23, ps24, ps25, ps26, ps27, ps28, ps29, ps30: integer;
begin
  { vpravo na znacku }
  jdi_vpravo_na(znacka, stav);
  { zapis prenos }
  write_inst(stav, znacka, 0, stav+1, 'R');
  { zapis znacku }
  for i:=-1 to 9 do
    write_inst(stav+1, i, znacka, stav+2, 'L');
  stav:=stav+2;
  { jdi na prvni cislo }
  vlevo_na_cislo(2, stav);  
  for i:=0 to 9 do begin
    pstav:=stav+1+i; zn:=letter+1+i;
    { prepis cislici znackou }
    ps1:=pstav; 
    write_inst(stav, i, zn, ps1, 'R');
    { posun na zac. dalsiho cisla }
    write_inst(ps1, -1, -1, ps1, 'R');
    { posun na konec cisla }
    ps2:=ps1+10;
    for j:=0 to 9 do
      write_inst(ps1, j, j, ps2, 'R');
    for j:=0 to 9 do
      write_inst(ps2, j, j, ps2, 'R');
    { krok zpet }
    ps3:=ps2+10;
    write_inst(ps2, -1, -1, ps3, 'L');
    { zapis znacku misto cislice }
    for j:=0 to 9 do begin
      v:=i+j; zn2:=letter+1+j;
      ps4:=ps3+10+j;
      {writeln(ps4, ': souctovy stav pro ', i, '+', j);}
      write_inst(ps3, j, zn2, ps4, 'R');
    end;
  end;

  { pro kazdy souctovy stav... }
  ps2:=ps3+1; ps5:=ps2+38; ps6:=ps2+39;
  for i:=0 to 18 do begin
    ps3:=ps2+i;
    { posun na koncovou znacku }
    for j:=-1 to 9 do
      write_inst(ps3, j, j, ps3, 'R');
    { pricti prenos }
    ps4:=ps3+19;
    write_inst(ps3, znacka, znacka, ps4, 'L');
    { zapis vysledek }
    if (i div 10)=0 then ps7:=ps5
    else ps7:=ps6;
    write_inst(ps4, 0, i mod 10, ps7, 'R');
    if ((i+1) div 10)=0 then ps7:=ps5
    else ps7:=ps6;
    write_inst(ps4, 1, (i+1) mod 10, ps7, 'R');
  end;
  { zapis prenos }
  ps7:=ps6+1;
  write_inst(ps5, znacka, 0, ps7, 'R');
  write_inst(ps6, znacka, 1, ps7, 'R');
  { zapis novou znacku }
  ps8:=ps7+1;
  for j:=-1 to 9 do
    write_inst(ps7, j, znacka, ps8, 'L');
  { jdi vlevo na znacku }
  for j:=-1 to 9 do
    write_inst(ps8, j, j, ps8, 'L');
  { prepis znacku na BLANK }
  ps9:=ps8+1; 
  for j:=0 to 9 do begin
    zn2:=letter+1+j;
    write_inst(ps8, zn2, -1, ps9, 'L');
  end;
  { je jeste co scitat? }
  ps10:=ps9+1;
  write_inst(ps9, -1, -1, ps10, 'L');

  { ps10: opis zbytku prvniho cisla }
  { jdi na znacku }
  for j:=-1 to 9 do
    write_inst(ps10, j, j, ps10, 'L');
  { prepis znacku na BLANK }
  ps11:=ps10+1; 
  for j:=0 to 9 do begin
    zn2:=letter+1+j;
    write_inst(ps10, zn2, -1, ps11, 'L');
  end;
  { prepis cislici }
  for i:=0 to 9 do begin
    pstav:=ps11+i+1; zn2:=letter+1+i;
    write_inst(ps11, i, zn2, pstav, 'R');
    { jdi na znacku }
    ps12:=pstav+10;
    for j:=-1 to 9 do
      write_inst(pstav, j, j, pstav, 'R');
    write_inst(pstav, znacka, znacka, ps12, 'L');
    { secti cislice }
    ps13:=ps12+10; ps14:=ps13+10;
    write_inst(ps12, 0, i, ps13, 'R');
    write_inst(ps12, 1, (i+1) mod 10, ps14, 'R');
    { zapis prenos }
    ps15:=ps14+10;
    write_inst(ps13, znacka, 0, ps15, 'R');
    write_inst(ps14, znacka, (i+1) div 10, ps15, 'R');
    { zapis znacku }
    for j:=-1 to 9 do
      write_inst(ps15, j, znacka, ps10, 'L');
  end;

  { p9: pokud nasleduji cislice... }
  ps16:=ps15+1;
  for j:=0 to 9 do
    write_inst(ps9, j, j, ps16, 'L');
  { jdi na znacku }
  for j:=-1 to 9 do
    write_inst(ps16, j, j, ps16, 'L');
  { prepis znacku na BLANK }
  ps17:=ps16+1;
  for j:=0 to 9 do begin
    zn2:=letter+1+j;
    write_inst(ps16, zn2, -1, ps17, 'L');
  end;
  { jsou dalsi cislice? }
  ps18:=ps17+1;
  write_inst(ps17, -1, -1, ps18, 'R');

  { ps18: opis zbytku druheho cisla }
  { preskoc mezery }
  write_inst(ps18, -1, -1, ps18, 'R');
  { na konec druheho cisla }
  ps19:=ps18+1;
  for j:=0 to 9 do
    write_inst(ps18, j, j, ps19, 'R');
  for j:=0 to 9 do
    write_inst(ps19, j, j, ps19, 'R');
  write_inst(ps19, -1, -1, ps11, 'L');

  { p17: pokud nasleduji cislice... }
  ps20:=ps19+1;
  for j:=0 to 9 do
    write_inst(ps17, j, j, ps20, 'R');
  { zpet do stavu 'stav' }
  for j:=-1 to 9 do
    write_inst(ps20, j, j, stav, 'L');

  { ps21: secteno}
  ps21:=ps20+1;
  write_inst(ps11, -1, -1, ps21, 'R');
  for j:=-1 to 9 do
    write_inst(ps21, j, j, ps21, 'R');
  { na prvni cislici }
  ps23:=ps21+1;
  write_inst(ps21, znacka, znacka, ps23, 'L');
  { vymaz nevyznamne nuly }
  write_inst(ps23, 0, -1, ps23, 'L');

  { proved reverzi cisla }
  ps24:=ps23+1;
  for i:=0 to 9 do begin
    pstav:=ps24+1+i; zn:=letter+1+i;
    if i>0 then write_inst(ps23, i, zn, pstav, 'R');
    for j:=-1 to 9 do
      write_inst(pstav, j, j, pstav, 'R');
    write_inst(pstav, znacka, i, ps24, 'R');
  end;
  { zapis znacku }
  ps25:=pstav+1;
  for j:=-1 to 9 do
    write_inst(ps24, j, znacka, ps25, 'L');
  { jdi na znacku }
  for j:=-1 to 9 do
    write_inst(ps25, j, j, ps25, 'L');
  { prepis znacku }
  ps26:=ps25+1;
  for j:=0 to 9 do begin
    zn2:=letter+1+j;
    write_inst(ps25, zn2, -1, ps26, 'L');
  end;
  { prepis cislici na znacku }
  for i:=0 to 9 do begin
    pstav:=ps24+1+i; zn:=letter+1+i;
    write_inst(ps26, i, zn, pstav, 'R');
  end;
  { skonceno? }
  ps27:=ps26+1;
  write_inst(ps26, -1, -1, ps27, 'R');
  for j:=-1 to 9 do
    write_inst(ps27, j, j, ps27, 'R');
  { zapis mezeru za cislo }
  ps28:=ps27+1;
  write_inst(ps27, znacka, -1, ps28, 'R');
  { zapis znacku }
  ps29:=ps28+1;
  for j:=-1 to 9 do
    write_inst(ps28, j, znacka, ps29, 'L');
  { a jdi na zacatek }
  for j:=-1 to 9 do
    write_inst(ps29, j, j, ps29, 'L');
  ps30:=ps29+1;
  write_inst(ps29, znacka, znacka, ps30, 'R');
  { vrat pocet stavu }
  stav:=ps30;
end;

{************************************
  vynasobi dve cisla
************************************}
procedure vynasob(var stav, letter: integer);
var i, j, pstav, ps1, ps2, ps3, ps4, ps7, ps8, ps9, 
  ps10, ps11, ps12, ps13, ps14, ps15, ps30: integer;
begin
  { vpravo na znacku }
  jdi_vpravo_na(znacka, stav);
  { krok vlevo }
  write_inst(stav, znacka, znacka, stav+1, 'L');
  stav:=stav+1;
  { jdi na prvni cislo }
  vlevo_na_cislo(2, stav);  
  for i:=0 to 9 do begin
    pstav:=stav+1+i;
    ps1:=pstav; 
    write_inst(stav, i, i, ps1, 'R');
    { posun na zac. dalsiho cisla }
    write_inst(ps1, -1, -1, ps1, 'R');
    { posun na konec cisla }
    ps2:=ps1+10;
    for j:=0 to 9 do
      write_inst(ps1, j, j, ps2, 'R');
    for j:=0 to 9 do
      write_inst(ps2, j, j, ps2, 'R');
    { krok zpet }
    ps3:=ps2+10;
    write_inst(ps2, -1, -1, ps3, 'L');
    { zapis znacku misto cislice }
    for j:=0 to 9 do begin
      ps4:=stav+31+(i*j) mod 10;
      write_inst(ps3, j, j, ps4, 'R');
    end;
  end;
  { pro kazdy nasobny stav... }
  ps2:=ps3+1; ps7:=stav+41;
  for i:=0 to 9 do begin
    ps3:=ps2+i;
    { posun na koncovou znacku }
    for j:=-1 to 9 do
      write_inst(ps3, j, j, ps3, 'R');
    { zapis vysledek }
    write_inst(ps3, znacka, i, ps7, 'R');
  end;
  { zapis mezeru a novou znacku }
  ps8:=ps7+1;
  for j:=-1 to 9 do
    write_inst(ps7, j, -1, ps8, 'R');
  ps9:=ps8+1;
  for j:=-1 to 9 do
    write_inst(ps8, j, znacka, ps9, 'L');

  { posun za vysledek }
  ps10:=ps9+1;
  write_inst(ps9, -1, -1, ps10, 'L');
  for j:=0 to 9 do
    write_inst(ps10, j, j, ps10, 'L');
  { posun na prvni soucinitel }
  ps11:=ps10+1;
  write_inst(ps10, -1, -1, ps11, 'L');
  write_inst(ps11, -1, -1, ps11, 'L');
  { smaz cislo }
  ps12:=ps11+1;
  for j:=0 to 9 do
    write_inst(ps11, j, -1, ps12, 'L');
  for j:=0 to 9 do
    write_inst(ps12, j, -1, ps12, 'L');
  ps13:=ps12+1;
  write_inst(ps12, -1, -1, ps13, 'L');
  { posun na dalsi cislo }
  write_inst(ps13, -1, -1, ps13, 'L');
  { smaz cislo }
  ps14:=ps13+1;
  for j:=0 to 9 do
    write_inst(ps13, j, -1, ps14, 'L');
  for j:=0 to 9 do
    write_inst(ps14, j, -1, ps14, 'L');
  ps15:=ps14+1;
  write_inst(ps14, -1, -1, ps15, 'L');

  { a jdi na zacatek }
  for j:=-1 to 9 do
    write_inst(ps15, j, j, ps15, 'L');
  ps30:=ps15+1;
  write_inst(ps15, znacka, znacka, ps30, 'R');
  { vrat pocet stavu }
  stav:=ps30;
end;

{*********************************
  nastavi hlavu na vysledek
*********************************}
procedure jdi_na_vysledek(var stav: integer);
var i, ps, ps2, ps3: integer;
begin
  for i:=-1 to 9 do
    write_inst(stav, i, i, stav, 'R');
  ps:=stav+1;
  write_inst(stav, znacka, znacka, ps, 'L');
  ps2:=ps+1;
  write_inst(ps, -1, -1, ps2, 'L');
  for i:=0 to 9 do
    write_inst(ps2, i, i, ps2, 'L');
  ps3:=ps2+1;
  write_inst(ps2, -1, -1, ps3, 'R');
  stav:=ps3;
end;

{************************************
  prepisuje strom do linearni formy
************************************}
procedure prepis_strom(t: PNode);
var k: integer;
begin
  if t<>nil then begin
    prepis_strom(t^.left);
    prepis_strom(t^.right);
    t^.stav1:=max_stav;
    if (t^.value>='0') and (t^.value<='9') then begin
      k:=ord(t^.value)-ord('1');
      vpravo_na_cislo(k, max_stav);
      prepis_cislo(max_stav, max_letter);
    end else if t^.value='+' then begin
      secti(max_stav, max_letter);
    end else if t^.value='*' then begin
      vynasob(max_stav, max_letter);
    end;
    t^.stav2:=max_stav;
  end;
end;


procedure TM;
begin
  max_stav:=0; max_letter:=9;
  zapis_znacky(max_stav, max_letter);
  prepis_strom(tree);
  jdi_na_vysledek(max_stav);
  writeln('-');
{  writeln('~ ~ >8 ~ 1 6  ~ 2 3 ~ 3 5 4 ~ 4 0 0 ~ 0 9 8 ~ 5 3 4 ~ 2 3 3 ~');}
end;


begin
  readln(N);
  while N>0 do begin
    build_tree;
    TM;
    N:=N-1;
  end;
end.

