program inspec;

(*#define DEBUG 1*)

const 
  MAX_D=1000000000;    
     

type
  PEdge = ^Edge;
  Edge = record
    from, t0, d:integer;
    next:PEdge;
  end;

var
  i, NN, N, M:integer;

procedure oneCase(N:integer; M:integer);
var
  i, D1, D2, t0:integer;
  nf:array [1..N] of Edge;
  ef:array [1..M] of Edge;

  (* add an edge to the graph *)
  procedure addEdge(var t0:Edge);
  var
    from:integer;

  begin
    from:=t0.from;
    t0.next:=nf[from].next;
    nf[from].next:=@t0; 
  end;

  (* suma *)
  function suma:integer;
  var
    i, D:integer;

  begin
    D:=0;
    for i:=1 to N do
      D:=D+nf[i].d;
    suma:=D; 
  end;

  (* perform breadth first algorithm *)
  procedure top;
  var
    first, f, l, newdist:integer;
    queue:array[0..N] of integer;
    ee:PEdge;

    function qEmpty:boolean;
    begin
      qEmpty:=f=l;
    end;

    function qFull:boolean;
    begin
      qFull:=((f + 1) mod N) = l;
    end; 

    function qPop:integer;
    begin
      qPop:=queue[l];
      l:=(l + 1) mod N;
    end;
   
    procedure qPush(x:integer);
    begin
      queue[f]:=x;
      f:=(f + 1) mod N;
    end; 

  begin
    f:=0; l:=0;
    nf[1].d:=0;
    qPush(1);

    while not qEmpty do
    begin
      first:=qPop;
      ee:=nf[first].next;
      nf[first].next:=nil;

#ifdef DEBUG
  writeln('  first ', first);
#endif DEBUG

      while ee<>nil do
      begin
        newdist:=nf[first].d + ee^.d; 
        if newdist < nf[ee^.t0].d then
        begin
          nf[ee^.t0].d:=newdist;
          qPush(ee^.t0);
        end;
        ee:=ee^.next;
      end;
    end;
  end;

begin
  D1:=0; D2:=0;

  for i:=1 to N do
  begin
    nf[i].d:=MAX_D;
    nf[i].next:=nil;
  end;

  for i:=1 to M do
  begin
    readln(ef[i].from, ef[i].t0, ef[i].d);
    ef[i].next:=nil;
    addEdge(ef[i]);
  end;

#ifdef DEBUG
  writeln('beginning 1st top');
#endif DEBUG

  top;
  D1:=suma;
  
  (* reverse graph *)
  for i:=1 to N do
  begin
    nf[i].d:=MAX_D;
    nf[i].next:=nil;
  end;

  for i:=1 to M do
  begin
    ef[i].next:=nil;
    t0:=ef[i].t0; ef[i].t0:=ef[i].from; ef[i].from:=t0;
    addEdge(ef[i]);
  end;

#ifdef DEBUG
  writeln('beginning 2nd top');
#endif DEBUG

  top;
  D2:=suma;

  writeln((D1 + D2):1);
end;


begin
  readln(NN);
  for i:=1 to NN do
  begin
    readln(N, M);
    oneCase(N, M);
  end;

end.
